#include "Principal.frm"

/*
 * Evento OnCreate.
 */
method PrincipalOnCreate( oSender ) class TPrincipal

 Request DbfCdx
   
   SELE 1
   IF !FILE("EXTRACTO.DBF")
     NEOBASE()
   EndIf
   USE EXTRACTO

   SET EPOCH TO 2000
   SET CENTURY ON
   SET DATE ITALIAN
   SET DECIMAL TO 2

   ::DbGrid1:Alignments := { taCenter,taRightJustify, taRightJustify, taCenter, taCenter, taLeftJustify,  taLeftJustify }
   ::DbGrid1:SetFocus() 
   ::Label3:Caption := OFICINA + " " + CUENTA
return

/*
 * Evento OnDblClick.
 */
method Borrar( oSender ) class TPrincipal
Sele 1
ZAP
::Label3:Caption := " "
::DbGrid1:SetFocus()
::DbGrid1:DataFirst()
::DbGrid1:Repaint() 
MessageDlg("Datos borrados",  mtInformation,;
             mbOk, poActiveCenter ) 
return

/*
 * Evento OnDblClick.
 */
method Importar( oSender ) class TPrincipal

local fi_impor := "", cVariable := SPACE(82)
PRIVATE aWork[24]
PRIVATE nBlee := 82
PRIVATE nArchEnt := saldo := 0
PRIVATE importa := .F.

fi_impor = FileMan("\*.*")
IF empty(fi_impor)
   MessageDLG("Proceso CANCELADO por el usuario",mtError, mbOk)
   RETURN
ENDIF  

I_MASIC(0)

nArchiEnt=FOPEN(fi_impor,0)
FREAD(nArchiEnt,@cVariable,nBlee)

DO CASE
  CASE BIN2I(SUBSTR(cVariable,81,1)) = 13 .AND. BIN2I(RIGHT(cVariable,1)) = 10
  // Fichero formato dos correcto
  CASE BIN2I(SUBSTR(cVariable,81,1)) = 10 .AND. RIGHT(cVariable,1) = "2"
  // Fichero formato dos sin retorno de carro
    nBlee = 81
  CASE RIGHT(cVariable,2) = "22"
  // Fichero sin avance de linea y sin retorno de carro
    nBlee = 80
  OTHERWISE
  // No se lo que he encontrado
    MessageDLG("Formato de Fichero incorrecto",mtError, mbOk)
    FCLOSE(nArchEnt)
    RETURN
ENDCASE
IF LEFT(cVariable,2) != "11"
   MessageDLG("El registro de Cabecera de cuenta es incorrecto;Proceso CANCELADO",mtError, mbOk)
   FCLOSE(nArchiEnt)
   RETURN NIL
ENDIF
FSEEK(nArchiEnt,0)
// datos de la cuenta
DO WHILE .T.
  nLee=FREAD(nArchiEnt,@cVariable,nBlee)
  IF nLee != nBlee
    EXIT
  ENDIF
  tipo=LEFT(cVariable,2)
  DO CASE
    CASE tipo="11"       // Cabecera de cuenta
      importa = .F.
      IF !EMPTY(aWork[1])
        GR_MOVI()
        I_MASIC(0)
      ENDIF
      aWork[1] = SUBSTR(cVariable,3,4)
      aWork[2] = SUBSTR(cVariable,7,4)
      aWork[3] = SUBSTR(cVariable,11,10)
      aWork[4] = VAL(SUBSTR(cVariable,34,12)+"."+SUBSTR(cVariable,46,2))
      aWork[5] = SUBSTR(cVariable,33,1)
          
    CASE tipo="22"       // Registro principal de movimiento
      IF aWork[12] != 0
        GR_MOVI()
        I_MASIC(1)
      ENDIF
      aWork[6] = SUBSTR(cVariable,7,4)
      aWork[7] = CONVFE(SUBSTR(cVariable,11,6))  //Fecha Operacion
      aWork[8] = CONVFE(SUBSTR(cVariable,17,6))  //Fecha Valor
      aWork[9] = SUBSTR(cVariable,23,2)
      aWork[10] = SUBSTR(cVariable,25,3)
      aWork[11] = SUBSTR(cVariable,28,1)
      aWork[12] = VAL(SUBSTR(cVariable,29,12)+"."+SUBSTR(cVariable,41,2))
      aWork[13] = SUBSTR(cVariable,43,10)
    CASE tipo="23"       //Ampliacion
      DO CASE
         CASE SUBSTR(cVariable,3,2) = "01"
            aWork[14] = SUBSTR(cVariable, 5,38)
            aWork[15] = SUBSTR(cVariable,43,38)
         CASE SUBSTR(cVariable,3,2) = "02"
            aWork[16] = SUBSTR(cVariable, 5,38)
            aWork[17] = SUBSTR(cVariable,43,38)
         CASE SUBSTR(cVariable,3,2) = "03"
            aWork[18] = SUBSTR(cVariable, 5,38)
            aWork[19] = SUBSTR(cVariable,43,38)
         CASE SUBSTR(cVariable,3,2) = "04"
            aWork[20] = SUBSTR(cVariable, 5,38)
            aWork[21] = SUBSTR(cVariable,43,38)
         CASE SUBSTR(cVariable,3,2) = "05"
            aWork[22] = SUBSTR(cVariable, 5,38)
            aWork[23] = SUBSTR(cVariable,43,38)
         ENDCASE
    CASE tipo="24"       //Equivalencia de Divisa
      IF aWork[12] != 0
        GR_MOVI()
        I_MASIC(1)
      ENDIF
      aWork[12] = VAL(SUBSTR(cVariable,8,12)+"."+SUBSTR(cVariable,20,2))
      aWork[14] = "EQUIVALENCIA PTS/EURO"
    CASE tipo="33"       //Fin cuenta
      IF aWork[12] != 0
        GR_MOVI()
        I_MASIC(0)
      ENDIF
      
    CASE tipo="88"       //Fin fichero SALIR
    OTHERWISE
      MessageDLG("Cdigo de registro Incorrecto en"+tipo,mtError, mbOk)
      EXIT
    ENDCASE
ENDDO
FCLOSE(nArchiEnt)
::Label3:Caption := OFICINA + " " + CUENTA
::DbGrid1:SetFocus()
::DbGrid1:DataFirst()
::DbGrid1:Repaint()
MessageDlg("Proceso finalizado Fichero importado",  mtInformation,;
             mbOk, poActiveCenter )
return


/*
 * Funcion buscar fichero para importar
 */
Function FileMan(mPara)

Local oFormFile, Edit1, FileSel1, FileSel2, FileSel3, vFile, Label1

   oFormFile := TForm():Create()
   oFormFile:OnClose := { | nAction | nAction := caFree }
   oFormFile:SetSize( 286, 150)
   oFormFile:Caption := "Seleccin de Fichero"
   oFormFile:position := poActiveCenter
   oFormFile:Icon:Name := "ESPIGA"
   oFormFile:BorderStyle := bsDialog

   Label1 := TLabel():Create( oFormFile )
   Label1:SetPos( 16, 16 )
   Label1:Caption := "Escriba o seleccione el fichero"

   Edit1 := TEdit():Create( oFormFile )
   Edit1:SetBounds( 16, 32, 225, 21 )

   vFile := TOpenDialog():Create( oFormFile )
   vFile:Caption := "Seleccione el fichero a recuperar"
   
   FileSel1 := TButton():Create( oFormFile )
   FileSel2 := TButton():Create( oFormFile )
   FileSel3 := TButton():Create( oFormFile )

   IF !Empty(mPara)
     vFile:FileName := mPara
   else
     mPara := ""
   endif
   vFile:Filter := { { "Texto plano *.txt", "*.txt" }, { "Todos *.*", "*.*" } }
    
   FileSel1:SetBounds( 248, 32, 25, 24 )
   FileSel1:Caption := "...."
   FileSel1:OnClick := { |oSender| Edit1:caption := iif(vFile:Execute(),vFile:FileName,"")}
   FileSel2:SetPos( 32, 72 )
   FileSel2:Caption := "OK"
   FileSel2:OnClick := { |oSender| mPara := Edit1:caption, oFormFile:close()}
   FileSel3:SetPos( 168, 72 )
   FileSel3:Caption := "Cancelar"
   FileSel3:OnClick := { |oSender| mPara := "", oFormFile:close()}

   oFormFile:ShowModal()
    
return mPara

FUNCTION I_MASIC(ini)
IF ini = 0
  aWork[1] = ""                // Nmero Oficina
  aWork[2] = ""                // Nmero Cuenta
  aWork[3] = ""                // Entidad
  aWork[4] = 0                 // Saldo Inicial
ENDIF
aWork[5] = ""                // Signo Saldo
aWork[6] = ""                // Oficina Origen
aWork[7] = CTOD("")          // Fecha Operacion
aWork[8] = CTOD("")          // Fecha Valor
aWork[9] = ""                // Concepto Comun
aWork[10] = ""                // Concepto Propio
aWork[11] = ""                // Signo
aWork[12] = 0                // Importe
aWork[13] = ""               // Nmero de documento
aWork[14] = ""               // Concepto 1
aWork[15] = ""               // Concepto 2
aWork[16] = ""               // Concepto 3
aWork[17] = ""               // Concepto 4
aWork[18] = ""               // Concepto 5
aWork[19] = ""               // Concepto 6
aWork[20] = ""               // Concepto 7
aWork[21] = ""               // Concepto 8
aWork[22] = ""               // Concepto 9
aWork[23] = ""               // Concepto 10
RETURN NIL

FUNCTION GR_MOVI()
IF importa
  RETURN NIL
ENDIF
DBAPPEND()
REPLACE ENTIDAD WITH aWork[1]
REPLACE OFICINA WITH aWork[2]
REPLACE CUENTA  WITH aWork[3]
REPLACE SALDOIN WITH aWork[4]
REPLACE O_ORIGE WITH aWork[6]
REPLACE F_OPERA  WITH aWork[7]
REPLACE F_VALOR  WITH aWork[8]
REPLACE C_COMUN  WITH aWork[9]
REPLACE C_PROPIO WITH aWork[10]
IF aWork[11] = "1"
  aWork[12] = -aWork[12]
ENDIF
REPLACE IMPORTE WITH aWork[12]
aWork[4] = aWork[4]+aWork[12]
REPLACE SALDOFI WITH aWork[4]
REPLACE N_DOCU  WITH aWork[13]
REPLACE CONCE1 WITH aWork[14]
REPLACE CONCE2 WITH aWork[15]
REPLACE CONCE3 WITH aWork[16]
REPLACE CONCE4 WITH aWork[17]
REPLACE CONCE5 WITH aWork[18]
REPLACE CONCE6 WITH aWork[19]
REPLACE CONCE7 WITH aWork[20]
REPLACE CONCE8 WITH aWork[21]
REPLACE CONCE9 WITH aWork[22]
REPLACE CONCE10 WITH aWork[23]
RETURN NIL

STATIC FUNCTION CONVFE(pFecha)
RETURN CTOD(RIGHT(pFecha,2)+"-"+SUBSTR(pFecha,3,2)+"-"+LEFT(pFecha,2))

FUNCTION QUITAPC()  //Elimina el ";" que da problemas con la exportacion
Local vTemp
PARAMETERS cadena
vTemp := STRTRAN(cadena,";",":")
Return(vTemp)

/*
 * Evento MenuItem OnClick.
 */
method exporta( oSender ) class TPrincipal
LOCAL fCopia := ""
PRIVATE v_campo :=""

GO TOP
fcopia := CUENTA+".csv"

nManejador := FCREATE(fCopia,0)

v_campo := "OFICINA;CUENTA;F_OPERA;IMPORTE;SALDOFI;CONCE1;CONCE2"+CHR(13)+CHR(10)
FWRITE(nManejador,v_campo)
v_campo := ""
Do while !EOF()

   v_campo := oficina+";"+cuenta+";"+TRANSFORM(f_opera,"dd/mm/aa")+";"+PUNTO(importe)+";"+PUNTO(saldofi)+";"+QUITAPC(conce1)+";"+QUITAPC(conce2)+CHR(13)+CHR(10)

/*
 *La base de datos tiene hasta 10 campos de concepto que rara vez se usan
 *Se pueden aadir 3,4,5,6,7,8,9 y 10
 *QUITAPC()  //Elimina el ";" que da problemas con la exportacion   
*/

   skip
Enddo
FCLOSE(nManejador)


   MessageDlg("Generado fichero "+fCopia,  mtInformation,;
             mbOk, poActiveCenter ) 
   ::DbGrid1:DataFirst()
   ::DbGrid1:Refresh()

return

Function PUNTO()   //cambia el punto por coma para generar el cvv
Local vTemp
PARAMETERS cadena
vTemp := TRANSFORM(cadena,"999999999999.99")
Return(STRTRAN(vTemp,".",","))

/*
 * Evento OnClose.
 */
method PrincipalOnClose( oSender, nAction ) class TPrincipal

  DBCloseAll()
  Close
  Quit

return

/*
 * Evento OnClick.
 */
method Salir() class TPrincipal

    DBCloseAll()
    Close
    Quit

return

/*
 * Evento OnClick. Filtro
 */
method Button1OnClick( oSender ) class TPrincipal
Local filtro := 0
vFiltro := ""
Dbsetfilter()

  IF !Empty(::LabeledEdit1:caption) //Importe menor
     filtro :=1
  EndIf

  IF !Empty(::LabeledEdit2:caption) //Importe mayor
     filtro := filtro +10
   EndIf
 
  If !Empty(::LabeledEdit3:caption) //Fecha desde
     filtro := filtro +100
  Endif
  
  If !Empty(::LabeledEdit4:caption) //Fecha hasta
     filtro := filtro + 1000
   Endif

  If !Empty(::LabeledEdit5:caption) //Concepot
     filtro := filtro + 10000
   Endif
   
Do case
  Case filtro = 1
     Set filter to Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 10
     Set filter to Extracto->Importe <= ::LabeledEdit2:caption
  Case filtro = 11
     Set filter to Extracto->Importe >= ::LabeledEdit1:caption .AND. Extracto->Importe <= ::LabeledEdit2:caption
  Case filtro = 100
     Set filter to Extracto->F_OPERA >= ::LabeledEdit3:caption
  Case filtro = 101
     Set filter to Extracto->Importe>= ::LabeledEdit1:caption .AND. Extracto->F_OPERA <= ::LabeledEdit1:caption
  Case filtro = 111
     Set filter to Extracto->F_OPERA >= ::LabeledEdit3:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption .AND.  Extracto->Importe <= ::LabeledEdit2:caption
  Case filtro = 1000
     Set filter to Extracto->F_OPERA <= ::LabeledEdit4:caption
  Case filtro = 1001
     Set filter to Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 1010
     Set filter to Extracto->F_OPERA <= ::LabeledEdit4:caption .AND.Importe <= ::LabeledEdit2:caption
  Case filtro = 1011
     Set filter to Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption .AND.  Extracto->Importe <= ::LabeledEdit2:caption
  Case filtro = 1100
     Set filter to Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption
  Case filtro = 1101
     Set filter to Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 1111
     Set filter to Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption .AND.  Extracto->Importe <= ::LabeledEdit2:caption .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption
  Case filtro = 10000
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0
  Case filtro = 10001  
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Importe >= ::LabeledEdit1:caption
  Case filtro = 10010
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Importe <= ::LabeledEdit2:caption
  Case filtro = 10011
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Importe <= ::LabeledEdit2:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 10100
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption
  Case filtro = 10101
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 10110
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption .AND. Importe <= ::LabeledEdit2:caption
  Case filtro = 10111
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption .AND. Importe <= ::LabeledEdit2:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 11000
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA <= ::LabeledEdit4:caption
  Case filtro = 11001
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 11010
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Importe <= ::LabeledEdit2:caption   
  Case filtro = 11011
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Importe <= ::LabeledEdit2:caption .and. Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 11100
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption
  Case filtro = 11101
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption .and. Extracto->Importe >= ::LabeledEdit1:caption
  Case filtro = 11110
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption .AND. Importe <= ::LabeledEdit2:caption
  Case filtro = 11111
     Set filter to AT(::LabeledEdit5:caption,CONCE1) != 0 .AND. Extracto->F_OPERA <= ::LabeledEdit4:caption .AND. Extracto->F_OPERA >= ::LabeledEdit3:caption .AND. Importe <= ::LabeledEdit2:caption .AND. Extracto->Importe >= ::LabeledEdit1:caption
EndCase

::DbGrid1:SetFocus()
::DbGrid1:DataFirst()
::DbGrid1:Repaint()

return

/*
 * Evento OnClick.
 */
method Button2OnClick( oSender ) class TPrincipal
vFiltro := ""
::LabeledEdit1:caption := 0.00
::LabeledEdit2:caption := 0.00
::LabeledEdit3:caption := CToD( "" )
::LabeledEdit4:caption := CToD( "" )
::LabeledEdit5:caption := space(38)

Dbsetfilter()
::DbGrid1:SetFocus()
::DbGrid1:DataFirst()
::DbGrid1:Repaint()
   

return

/*
 * Evento OnChange.
 */
method DbGrid1OnChange( oSender ) class TPrincipal
   
  ::Label2 := OFICINA
  ::Label3 := CUENTA

return

/*
 * SIno existe la base de datos extracto, la creo
*/
//EMIBASE
FUNCTION NEOBASE()
LOCAL aSemi := { ;
     { "ENTIDAD"    ,"C", 4, 0 }, ;
     { "OFICINA"    ,"C", 4, 0 }, ;
     { "CUENTA"     ,"C",10, 0 }, ;
     { "O_ORIGE"    ,"C", 9, 0 }, ;
     { "F_OPERA"    ,"D", 8, 0 }, ;
     { "F_VALOR"    ,"D", 8, 0 }, ;
     { "C_COMUN"    ,"C", 2, 0 }, ;
     { "C_PROPIO"   ,"C", 3, 0 }, ;
     { "IMPORTE"    ,"N",15, 2 }, ;
     { "SALDOIN"    ,"N",15, 2 }, ;
     { "SALDOFI"    ,"N",15, 2 }, ;
     { "N_DOCU"     ,"C",10, 0 }, ;
     { "REFE1"      ,"C",12, 0 }, ;
     { "REFE2"      ,"C",16, 0 }, ;
     { "CONCE1"     ,"C",38, 0 }, ;
     { "CONCE2"     ,"C",38, 0 }, ;
     { "CONCE3"     ,"C",38, 0 }, ;
     { "CONCE4"     ,"C",38, 0 }, ;
     { "CONCE5"     ,"C",38, 0 }, ;
     { "CONCE6"     ,"C",38, 0 }, ;
     { "CONCE7"     ,"C",38, 0 }, ;
     { "CONCE8"     ,"C",38, 0 }, ;
     { "CONCE9"     ,"C",38, 0 }, ;
     { "CONCE10"    ,"C",38, 0 }, ;
   }


DbCreate("EXTRACTO", aSemi, "DBFCDX" )

RETURN